;
; IMPORTANTE >>>>>>>>  assemblare con opzione    c-     <<<<<<<<<<<
;*******************************************************************
; nome file :               TACHO.ASM
;            Tachimetro x moto/bici
;versione 
; v. 1          inizio  29/10/99                                01/11/99
; v. 2          aggiunto conv. BIN2BCD 24 bit
; 05/11/99      ultimo  aggiornamento
;*******************************************************************
;
        LIST    p=16F84
;
        ERRORLEVEL -302
;
        Radix   DEC
;
        include <P16F84.inc>
;
        __FUSES   _XT_OSC&_CP_OFF&_PWRTE_ON&_WDT_OFF
;
;
;**********************************************************************
;quarzo = 4.000.000Hz = 1usec * istruzione
;
;**********************************************************************
;
;   costanti    sistema
msb_bit         equ     7               ;define for bit 7
lsb_bit         equ     0               ;define for bit 0
ruota           equ     2035            ;circonferenza ruota in mm.
dividendo       equ     1800 * ruota    ;per avere la velocita' in Km/h
;si moltiplica x 1800 anziche 3600 in quanto  TMR0 incr. ogni 2usec
centomila       equ     100000          ;per calcolo km
DISP_ON         equ     12              ; Display on
DISP_ON_BC      equ     15              ; Display on, Cursor on, Blink cursor
Pu1             equ     1               ;input  pulsante sel. Funzione
Pu2             equ     2               ;input  pulsante conferma & power ON
N_eleme         equ     16              ;numero elementi visualizz. a barra
Shape           equ     255             ;simbolo barra in range
Sh_LO           equ     127             ;simbolo barra in lowerange
V_M_barra       equ     60              ;f. s. vel. max della barra analog.
;
;
;
;--------------------------------
; Definizioni    pin  I/O
;
; -----------------> Port A <--
;
;       equ     0       ;input  pulsante sel. Funzione
;       equ     1       ;input  pulsante conferma & power ON
;       equ     2       ;
Auto_m  equ     3       ;out    automantenimento alimentazione
Led     equ     4       ;out    x diagnosi copia di intB
;
; -----------------> Port B <--
;
;       equ     0       ;input   sensore ruota   attivo fronte discesa
Lo_ba   equ     1       ;input   Low batt.
En      equ     2       ;out     enable display
Rs      equ     3       ;out     register select display
;       equ     4       ;out     bus dati4 display LM016
;       equ     5       ;out     bus dati5  "
;       equ     6       ;out     bus dati6  "
;       equ     7       ;out     bus dati7  "
;
;*******************************
;
; file Registri
        cblock  12
;
;          uso   generale
r1
r2
r3
r4
r5
r_t                             ;delay x display
;        riservati  sistema
savew                           ; salva  W      durante interrupt
savest                          ; salva  STATUS     "      "
flag1                           ; usato a bit
button                          ;deposito lettura pulsanti
funct                           ;quale funzione visualizza su II riga
;
;       riservati  display
char                            ;deposito carattere da visualizzare
txtptr                          ;puntatore tabelle testo in rom
;
;       riservati  tachimetro / contaKm
;
V_picco                         ;vel. max
V_att                           ;velocita' attuale
dot_bar                         ;velocita' visual. dalla barra
;
Tim_Lo                          ;copia di TMR0
Tim_Mi                          ;aggiornata ad ogni int. do TMR0
Tim_Hi                          ;ovvero ogni 512usec.
;
Mir_Lo                          ;conserva una copia per il calcolo
Mir_Mi                          ;della velocita'
Mir_Hi                          ;aggiornata quando riceve int. Rb0
;
; i segg. sono salvati in eeprom  NON TOCCARE
Tot_Lo                          ;totalizzatore impulsi sensore
Tot_Mi                          ;ovvero spazio percorso
Tot_Hi                          ;aggiornato quando riceve int. Rb0
;
Par_Lo                          ;contatore impulsi parziali sensore
Par_Mi                          ;aggiornato insieme Tot_xx
Par_Hi                          ;
;
Bar_max                         ;vel. max. visualizz. dalla barra
;si puo' configurare per diversi valori di fondo scala  il valore
;
;       Math related registers
;
ACCaHI                          ;24-Bit accumulator a
ACCaMID
ACCaLO
;
ACCbHI                          ;24-Bit accumulator b
ACCbMID
ACCbLO
;
ACCcHI                          ;24-Bit accumulator c
ACCcMID
ACCcLO
;
ACCdHI                          ;24-Bit accumulator d
ACCdMID
ACCdLO
;
temp                            ;temporary storage
;
        endc
;
;   riassegna per la conversione bin bcd a 24 bit
;
reg0    set     ACCaHi          ;lsd del valore binario da convertire
reg1    set     ACCaMid
reg2    set     ACCaLo          ;msd
;    NON cambiare l'ordine
dig0    set     ACCbHi          ;lsd del valore BCD convertito
dig1    set     ACCbMid
dig2    set     ACCbLo
dig3    set     ACCcHi          ;msd
;
;..........
;   bit di flag1
;       equ     7       ;
;       equ     6       ;
;       equ     5       ;
V_km    equ     4       ;visualizza vel. o km
New     equ     3       ;valore disponibile per il calcolo
Er_int  equ     2       ;verificatosi errore int
Dly     equ     1       ;ritardo lungo x display lcd
D_reg   equ     0       ;1= data regist.  0= command regist.
;
;
;**********************************************************************
;               MACRO
;  copia il registro source in destinazione
;      modifica W
COPYF        macro   source,destinazione
         movfw   source
        movwf   destinazione
        endm
;
;  invia il messaggio che inizia da txtlabel al display
SEND         macro   txtlabel
        movlw   LOW txtlabel
        movwf   txtptr
        call    invia_txt
        endm
;
;    confronta il valore literal con il contenuto di FR
;    se fr #  da literal  salta ad etich
;      modifica W
CJNUG       macro   literal,fr,etich        ;compare jmp se diverso
        movlw   literal
        subwf   fr,w
        bnz     etich
        endm
;
;    confronta il valore literal con il contenuto di FR
;    se fr #  da literal  skip l'istruzione seguente
;      modifica W
CSNUG       macro   literal,fr              ;compare skip se diverso
        movlw   literal
        subwf   fr,w
        skpnz
        endm
;
;    confronta il valore literal con il contenuto di FR
;    se fr = literal  salta ad etich
;      modifica W
CJUG        macro   literal,fr,etich        ;compare jmp se uguale
        movlw   literal
        subwf   fr,w
        bz      etich
        endm
;
;    confronta il valore literal con il contenuto di FR
;    se fr = literal  skip l'istruzione seguente
;      modifica W
CSUG        macro   literal,fr              ;compare skip se uguale
        movlw   literal
        subwf   fr,w
        skpz
        endm
;
;    confronta il valore literal con il contenuto di FR
;    se fr > o = di literal salta ad etich
;      modifica W
CJMAGUG        macro   literal,fr,etich        ;compare jmp se mag. o uguale
        movlw   literal
        subwf   fr,w
        bc      etich
        endm
;
;    confronta il valore literal con il contenuto di FR
;    se fr < di literal salta ad etich
;      modifica W
CJMIN        macro   literal,fr,etich        ;compare jmp se minore
        movlw   literal
        subwf   fr,w
        bnc     etich
        endm
;
;**********************************************************************
;
        ORG     0
        clrf    PortA           ;predispone i latch d'uscita dei port
        clrf    PortB           ;disattivi (per ora)
        goto    inizio
;
        ORG     4
;
INTRP
        movwf   savew           ;Save W
        swapf   status,w        ;affects no STATUS bits
        bcf     status,rp0      ;BACK TO LO REGS
        movwf   savest          ;Save STATUS Reg
;
        movfw   tmr0            ;salva subito e sempre timer
; sarebbe da sottrarre il tempo impiegato a giungere qui
; ma l'errore e' piccolo e non merita
        movwf   Tim_lo
        btfss   INTCON,intf     ;Service interrupt  RB0
        goto    tmr0int         ;no prova se timer
;
        bcf     PortA,led       ;accende led x debug
        btfsc   flag1,new       ;controlla se main ha gia' letto
        goto    lascia          ;per non mischiare dati di letture diverse
      copyf     Tim_lo,Mir_lo   ;trasferisce nel mirror
      copyf     Tim_mi,Mir_mi   ;i valori acquisiti
      copyf     Tim_hi,Mir_hi
        bsf     flag1,new       ;segnala dati disponibili
lascia
        clrf    Tim_lo          ;riazzera per la prossima misura
        clrf    Tim_mi
        clrf    Tim_hi
;
        incf    Tot_lo,f        ;aggiorna totalizzatore Km
        skpnz
        incf    Tot_mi,f
        skpnz
        incf    Tot_hi,f
;
        incf    Par_lo,f        ;aggiorna parziale Km
        skpnz
        incf    Par_mi,f
        skpnz
        incf    Par_hi,f
;
        bcf     INTCON,intf     ;libera per prossimo int
        clrf    tmr0            ;riavvia nuovo ciclo misura
        goto    restint
;
Tmr0int
        btfss   INTCON,t0if     ;Service timer overflow
        goto    rb74int         ;no prova se int cambio stato
;
        incf    Tim_mi,f        ;aggiorna contatore
        skpnz                   ;tempo rivoluzione ruota
        incf    Tim_hi,f
        bcf     INTCON,t0if     ;libera per prossimo int
        goto    restint
;
Rb74int                         ;se arriva qui ha sbagliato
        bsf     flag1,er_int
Restint
        swapf   savest,w
        movwf   status          ;restore STATUS Reg
        swapf   savew,f
        swapf   savew,w         ;restore WREG
        retfie                  ;riattiva GIE automaticamente
;
;***************************************************
;ATTENZIONE    le tabelle non devono attraversare la pagina
Table_begin     equ     $
;
;--------------   Tabelle dati
;
;
TABLCD
        addwf pcl,f     ;add program counter
;
        dt      33h,33h,33h,2Ch,06,0Ch,01,02
;
;;      00110011b       ;initialise lcd - first byte
;;      00110011b       ;2nd byte (repeat of first)
;;      00110010b       ;set for 4-bit operation
;;      00101100b       ;set for 2 lines
;;      00000110b       ;set entry mode to increment each address
;;      00001100b       ;set display on, cursor off, blink off
;;      00000001b       ;clear display
;;      00000010b       ;return home, cursor & RAM to zero
;
;
;-------------    Tabelle  messaggi al display  max. 16 car. x riga
;
Messag
        movwf   pcl
;
Kmh     dt      "Km/h",0
;
Km      dt       "Km",0
;
Pik     dt       "Max.",0
;
Tot     dt       " Tot",0
;
Par     dt       " Par",0
;
Killtot
        dt      12,"CLR tot.",0
;
Killpar
        dt      12,"CLR parz.",0
;
Spegni
        dt      12,"POWER Off",0
;
Set_bar
        dt      12,"Set Barra",0
;
Okk
        dt      10,"Ok = P2",0
;
Ciao
        dt      12,"Bye",0
;
Banner
        dt      12,"Speed Meter v.2",0
;
Finito
        dt      12,"EXIT",0
;
Lo_batt
        dt      12,"Lo. Batt.",0
;
Table_end       equ     $
;
; controlla che rientri in una pagina
   if ( ( HIGH Table_begin ) < ( HIGH table_end ) )
        MESSG   "ATTENZIONE --- : Tabella attraversa pagina"
   endif
;
;
;                   -----------------------------
;                     ------- PROCEDURE --------
;                   ------------------------------
;
;*******************************
R30ms
        movlw   30
        goto    rwms
;*******************************
R100ms
        movlw   100
        goto    rwms
;*******************************
R15ms
        movlw   15
;NON SPOSTARE
;*******************************
;ritardo  W volte * 1msec   circa !!
RWms
        movwf   r_t             ;quante volte fare 1msec
w_1ms
        movlw   200             ;per avere ~ 1 msec con clock a 4MHz
;
        clrwdt                  ;timeout WDT  7 msec  (caso peggiore)
        addlw   -1              ;emula   DECrementa W    che non esiste
        skpz                    ;quando raggiunge 0 ha finito
        goto    $-3
        decfsz  r_t,f
        goto    w_1ms
        return
;
;*******************************
;legge i pulsanti e maschera i bit che non servono ritorna in W la lettura
Zap
        comf    PortA,w         ;lettura pulsanti
        andlw   00000011b       ;toglie quello che non serve
        return
;
;*******************************
;legge i pulsanti  e ritorna risultato in button
Tasti
        call    r30ms           ;I debounce
        call    zap             ;I lettura pulsanti
        movwf   button          ;conserva
        call    r30ms           ;II debounce
        call    zap             ;II rilettura
        subwf   button,w        ;se le 2 letture sono = e' valida
        bnz     tasti           ;riprova fino ad avere letture uguali
        return
;
;*******************************
;attende rilascio / pressione pulsante
Flip
        call    tastof          ;attende rilascio tasto
;;;;    goto    taston          ;attende pressione tasto
;;;;    return
; NON  SPOSTARE da qui
;*******************************
; rimane in loop finche'non rileva la pressione di un tasto
TASTon
        call    tasti           ;legge
        movfw   button          ;riprende il valore
        skpz
        return                  ;almeno un pulsante premuto
        goto    taston
;
;*******************************
; ritorna quando rileva  il rilascio del tasto
TASTof
        call    tasti           ;legge
        movfw   button          ;riprende il valore
        skpnz
        return                  ;deve leggere 00
        goto    tastof
;
;*******************************
; Scrive in EEPROM alla locaz. indicata da EEADR (da predisporre prima)
; il valore presente in EEDATA  (da predisporre prima)
WriteEEprom
        bcf     INTCON,gie
        btfsc   INTCON,gie      ;necessario ricontrollo
        goto    $-1
        bsf     STATUS,rp0      ;in pagina 1
        bsf     EECON1,wren     ;write enable
        movlw   55h
        movwf   EECON2
        movlw   0AAh
        movwf   EECON2
        bsf     EECON1,wr       ;start  scrittura
Wteeif
        clrwdt
        btfss   EECON1,eeif     ;diventa a 1 quando termina la scrittura
        goto    wteeif          ;attende fine scrittura
        bcf     EECON1,eeif     ;bisogna resettarlo
        bcf     EECON1,wren
        bcf     STATUS,rp0      ;ritorna in pagina 0
        bsf     INTCON,gie      ;riattiva int
        return
;
;*******************************
;legge dalla EEPROM alla locaz. indicata da EEADR (da predisporre prima)
;il dato letto risulta disponibile in EEDATA
ReadEEprom
        bsf     STATUS,rp0      ;in pagina 1
        bsf     EECON1,rd
        bcf     STATUS,rp0      ;ritorna in pagina 0
        return
;
;*******************************
; Inizializza display a parola dati di 4 bit  (2 scritture consecutive)
LCD_Init
        call    r15ms           ;minimo 15msec  dal power up
        movlw   HIGH Tablcd
        movwf   pclath          ;punta correttamente
        clrf    r3              ;puntatore tabella
lcd2in
        movfw   r3
        call    TABLCD          ;get set-up instruction
        call    Wr_cmd          ;forza l'invio al command reg.
        call    r15ms           ;inserisce sempre ritardo lungo
        incf    r3,f            ;aggiorna puntatore
        btfss   r3,3            ;ha inviato tutti gli 8 byte ?
        goto    lcd2in
        return
;da ora in poi la gestione del display deve avvenire a 4 bit
;
;*******************************
;converte in HEX  W e lo invia al display
Hexout
        movwf   r5              ;salva
        swapf   r5,w            ;prima la parte alta
        call    hexasc
        movfw   r5              ;adesso parte bassa
;;;     call    hexasc
;;;;    return
;;NON SPOSTARE
;*******************************
;converte il nibble basso di W in  HEX  e lo invia al display
HEXasc
        andlw   15              ;solo parte bassa
        addlw   256-10          ;test se da  A a F  (= sub 10 )
        skpnc                   ;se CY=0  e' un numero 0 9
        addlw   7               ;aggiusta per A F
        addlw   58              ;corregge per le somme di prima
        goto    printW
;;;;    return
;
;*******************************
; invia impulso Enable al display
PULS_en
        movfw   char            ;riprende dato
        andlw   11110000b       ;lascia parte alta
        movwf   PortB           ;dato stabile su port uscita
        btfsc   flag1,D_reg     ;deve inviare al data o al command reg.?
        bsf     PortB,Rs        ;seleziona data reg.
        bsf     PortB,En        ;enable attivo
        clrwdt                  ;allunga un po' impulso
        bcf     PortB,En        ;latch dato su fronte discesa
        return
;
;*******************************
;invia uno spazio al display
Spazio
        movlw   ' '
        goto    printW
;;;;    return
;
;*******************************
;Invia il carattere in W al command register del display
;usato per movimenti cursore e altre operazioni su display
WR_cmd
        movwf   char            ;salva codice
        bcf     flag1,D_reg     ;indirizza registro comandi
        goto    xmit            ;e lo invia al display
;
;*******************************
;Invia il carattere in W alla data ram del display
;riconosce il codice 12 come clear display
;    "          "    11 come cursore ad inizio I riga ( Home )
;    "          "    10 come cursore ad inizio II riga (Home Lower)
;questo per comodita' nella scrittura dei messaggi
;per inviare altri cod. di controllo usare WR_cmd e considerare
;se inserire il ritardo secondo  specifiche del display
PrintW
        movwf   char            ;salva  carattere
     cjnug   10,char,pr_k2      ;Home lower ?
        movlw   192             ;posiziona cursore
        goto    WR_cmd          ;e lo tratta come un comando
pr_k2
     cjnug   11,char,pr_k3      ;Home upper ?
        movlw   128             ;posiziona cursore
        goto    WR_cmd          ;e lo tratta come un comando
pr_k3
     cjnug   12,char,pr_cch     ;Cls ?
        bsf     flag1,dly       ;richiede  ritardo lungo
        movlw   1               ;codice clear display
        goto    WR_cmd          ;e lo tratta come un comando
pr_cch
        bsf     flag1,D_reg     ;seleziona registro dati
Xmit                            ;entry per codici al comand register
        call    puls_en         ;invia prima Hi nibble
        swapf   char,f
        call    puls_en         ;e poi invia Lo nibble
        movlw   2               ;presuppone serve ritardo 2msec
        btfsc   flag1,dly       ;deve eseguire ritardo ?
        call    rwms            ;lo esegue
        bcf     flag1,dly       ;toglie flag ritardo per prossimo invio
        movlw   15              ;inserisce sempre ~60 usec di ritardo
        addlw   -1              ;1ck    decr W
        skpz                    ;1ck
        goto    $-2             ;2ck
        return
;
;*******************************
;invia il testo prelevato dalla tabella in ROM al  display
INVIA_txt
        movlw   HIGH Messag     ;da qui iniziano tutti i messaggi
        movwf   pclath          ;la tabella NON deve attraversare la pagina
invtx1
        movfw   txtptr          ; puntatore offset in W
        call    Messag          ;inizio deposito tutti i messaggi
        andlw   255             ;controllo se = 0  senza modificare W
        skpnz                   ; se = 0 fine messaggio
        return
        call    PrintW          ; invia carattere con gestione CLS display
        incf    txtptr,f        ; passa al dato segg.
        goto    invtx1
;
;*******************************
;Estensione a Binbcd per portarlo nel range 0 255 effettua direttamente
;l'invio al display del valore di W convertito in BCD
L_bcd
        movwf   r3              ;salva temporaneamente
      cjmin     200,r3,II_test
        movlw   '2'             ;display centinaia
        call    printW
        movlw   200             ;sottrae 200
        subwf   r3,f            ;lascia risultato in r3
        goto    B_bcd           ;converte e visualizza il resto
II_test
      cjmin     100,r3,B_bcd    ;in range 0 - 99
        movlw   '1'             ;display centinaia
        call    printW
        movlw   100             ;tra 100 e 199
        subwf   r3,f            ;lascia risultato in r3
;
;converte  W in BCD e ritorna in  W il risultato
;ATTENZIONE solo nel range  00 - 99  i risultati sono validi
B_bcd
;;;;    movwf   r3              ;modificato per estensione  a 255
        clrf    r4
binb1
        movlw   10
        subwf   r3,w
        BTFSS   STATUS,C
        goto    binb2
        movwf   r3
        incf    r4,f
        goto    binb1
binb2
        swapf   r4,w
        iorwf   r3,w
;
        goto    hexout          ;invio al display
;;      return
;
;*******************************
;ricarica il totalizzatore di pulse preleva da eeprom
;i valori salvati al momento dello spegnimento
Load_dati
        call    pred_ee         ;predispone parametri scritt/lett
ed1
        call    readeeprom
     copyf      EEDATA,INDF     ;salva il valore letto
        incf    EEADR,f
        incf    FSR,f           ;agg. i pointer punta gia alla prossima
        decfsz  r1,f            ;per quante volte
        goto    ed1
        return
;
;*******************************
;salva il totalizzatore di pulse in eeprom
;per conservare il valore durante lo spegnimento
Save_dati
        call    pred_ee         ;predispone parametri scritt/lett
ed2
      copyf     INDF,EEDATA     ;salva il valore letto
        call    writeeeprom
        incf    EEADR,f
        incf    FSR,f           ;agg. i pointer punta gia alla prossima
        decfsz  r1,f            ;per quante volte
        goto    ed2
        return
;
;*******************************
;predispone per le operazioni scritt/lett in eeprom
Pred_ee
        movlw   Tot_Lo
        movwf   FSR             ;puntatore deposito dati letti da eeprom
        movlw   7               ;quanti dati leggere  3 + 3 + 1
        movwf   r1              ;nel contatore
        movlw   0               ;ind eeprom
        movwf   eeadr
        return
;
;*------------------------------------------------
;*-     24-bit Addition
;*-
;*-     Uses ACCa and ACCb
;*-
;*-     ACCa + ACCb -> ACCb
;*------------------------------------------------
Add24
        movf    ACCaLO,W
        addwf   ACCbLO,f        ;add low bytes
        btfsc   STATUS,C        ;add in carry if necessary
        goto    A2
A1
        movf    ACCaMID,W
        addwf   ACCbMID,f       ;add mid bytes
        btfsc   STATUS,C        ;add in carry if necessary
        incf    ACCbHI,f
        movf    ACCaHI,W
        addwf   ACCbHI,f        ;add high bytes
        retlw   0
A2
        incf    ACCbMID,f
        btfsc   STATUS,Z
        incf    ACCbHI,f
        goto    A1
;
;*------------------------------------------------
;*-     Subtraction ( 24 - 24 -> 24 )
;*-
;*-     Uses ACCa, ACCb, ACCd
;*-
;*-     ACCa -> ACCd,
;*-     2's complement ACCa,
;*-     call Add24 ( ACCa + ACCb -> ACCb ),
;*-     ACCd -> ACCa
;*------------------------------------------------
Sub24
        movf    ACCaHI,W                ;Transfer ACCa to ACCd
        movwf   ACCdHI
        movf    ACCaMID,W
        movwf   ACCdMID
        movf    ACCaLO,W
        movwf   ACCdLO
        call    compA                   ;2's complement ACCa
        call    Add24                   ;Add ACCa to ACCb
        movf    ACCdHI,W                ;Transfer ACCd to ACCa
        movwf   ACCaHI
        movf    ACCdMID,W
        movwf   ACCaMID
        movf    ACCdLO,W
        movwf   ACCaLO
        retlw   0
;
;*-------------------------------------------------
;*-     Multiply ( 24 X 24 -> 56 )
;*-
;*-     Uses ACCa, ACCb, ACCc, ACCd
;*-
;*-     ACCa * ACCb -> ACCb,ACCc  56-bit output
;*-     with ACCb (ACCbHI,ACCbMID,ACCbLO) with 24 msb's and
;*-     ACCc (ACCcHI,ACCcMID,ACCcLO) with 24 lsb's
;*-------------------------------------------------
Mpy24
        call    Msetup
mloop
        rrf     ACCdHI,f        ;rotate d right
        rrf     ACCdMID,f
        rrf     ACCdLO,f
        btfsc   STATUS,C        ;need to add?
        call    Add24
        rrf     ACCbHI,f
        rrf     ACCbMID,f
        rrf     ACCbLO,f
        rrf     ACCcHI,f
        rrf     ACCcMID,f
        rrf     ACCcLO,f
        decfsz  temp,f          ;loop until all bits checked
        goto    mloop
        retlw   0
Msetup
        movlw   0x18            ;for 24 bit shifts
        movwf   temp
        movf    ACCbHI,W        ;move ACCb to ACCd
        movwf   ACCdHI
        movf    ACCbMID,W
        movwf   ACCdMID
        movf    ACCbLO,W
        movwf   ACCdLO
        clrf    ACCbHI
        clrf    ACCbMID
        clrf    ACCbLO
        retlw   0
;
;*--------------------------------------------------
;*-     Division ( 56 / 24 -> 24 )
;*-
;*-     Uses ACCa, ACCb, ACCc, ACCd
;*-
;*-     56-bit dividend in ACCb,ACCc ( ACCb has msb's and ACCc has lsb's)
;*-     24-bit divisor in ACCa
;*-     quotient is stored in ACCc
;*-     remainder is stored in ACCb
;*--------------------------------------------------
Div24
        call    Dsetup
dloop
        bcf     STATUS,C
        rlf     ACCcLO,f        ;Rotate dividend left 1 bit position
        rlf     ACCcMID,f
        rlf     ACCcHI,f
        rlf     ACCbLO,f
        rlf     ACCbMID,f
        rlf     ACCbHI,f
;
        btfsc   STATUS,C        ;invert carry and exclusive or with the
        goto    clear           ;msb of the divisor then move this bit
        btfss   ACCaHI,msb_bit  ;into the lsb of the dividend
        incf    ACCcLO,f
        goto    cont
clear
        btfsc   ACCaHI,msb_bit
        incf    ACCcLO,f
cont
        btfsc   ACCcLO,lsb_bit  ;check the lsb of the dividend
        goto    minus
        call    Add24           ;if = 0, then add divisor to upper 24 bits
        goto    check           ;of dividend
minus
        call    Sub24           ;if = 1, then subtract divisor from upper
;                               ;24 bits of dividend
check
        decfsz  temp,f          ;do 24 times
        goto    dloop
;
        bcf     STATUS,C
        rlf     ACCcLO,f        ;shift lower 24 bits of dividend 1 bit
        rlf     ACCcMID,f       ;position left
        rlf     ACCcHI,f
        btfsc   ACCbHI,msb_bit  ;exlusive or the inverse of the msb of the
        goto    w1              ;dividend with the msb of the divisor
        btfss   ACCaHI,msb_bit  ;store in the lsb of the dividend
        incf    ACCcLO,f
        goto    wzd
w1
        btfsc   ACCaHI,msb_bit
        incf    ACCcLO,f
wzd
        btfss   ACCbHI,msb_bit  ;if the msb of the remainder is set and
        goto    wend
        btfsc   ACCaHI,msb_bit  ;the msb of the divisor is not
        goto    wend
        call    Add24           ;add the divisor to the remainder to correct
;                               ;for zero partial remainder
wend    retlw   0               ;quotient in 24 lsb's of dividend
;                               ;remainder in 24 msb's of dividend
;
Dsetup
        movlw   0x18            ;loop 24 times
        movwf   temp
        retlw   0
;
;*********************
;azzera tutto l'accumulatore matematico
Azz_acc
        movlw   12              ;quanti byte azzerare
        movwf   r1
        movlw   ACCaHi          ;da inizio acc
        movwf   fsr
azz_lp
        clrf    indf
        incf    fsr,f
        decfsz  r1,f
        goto    azz_lp
        return
;
;*--------------------------------------------------
;*-     2's Complement
;*-
;*-     Uses ACCa
;*-
;*-     Performs 2's complement conversion on ACCa
;*--------------------------------------------------
compA
        comf    ACCaLO,f          ;invert all bits in accumulator a
        comf    ACCaMID,f
        comf    ACCaHI,f
        incf    ACCaLO,f        ;add one to accumulator a
        btfsc   STATUS,Z
        incf    ACCaMID,f
        btfsc   STATUS,Z
        incf    ACCaHI,f
        retlw   0
;
;*--------------------------------------------------
; Rewrite of b2bcd for less space; inlined it.
bin2bcd
        movlw   24
        movwf   r1
        clrf    dig0            ;clear result to all 0.
        clrf    dig1
        clrf    dig2
        clrf    dig3
b2bcdl
        movlw   dig0            ;Point at first bcd
        movwf   FSR
; Copy of 'adjbcd'.  OK to adjust the first time before shifting.
b2bcdil
        movlw   33h
        addwf   INDF,f          ;Add to low and high nybbles
        btfsc   INDF,3
        andlw   0f0h            ;Low result >7 . OK (take the 3 out)
        btfsc   INDF,7
        andlw   0fh             ;Hi > 7 OK.
        subwf   INDF,f          ;any results <=7, subtract back.
        incf    FSR,f           ;Inc. pointer for next time
;bcd placed at known address, so bits in FSR could be used for loop control
        btfss   FSR,4           ;When FSR reaches 0x10, done.
        goto    b2bcdil         ;If not done, do the inner loop again.
;
        rlf     reg0,f
        rlf     reg1,f
        rlf     reg2,f         ;Get another bit out of bin.
;
        rlf     dig0,f         ;Put bit into bcd.
        rlf     dig1,f
        rlf     dig2,f
        rlf     dig3,f
;
        decfsz  r1,f            ;Do more?
        goto    b2bcdl          ;Yes.
        return
;
;
;.......................................................................
;
;                  -------------------------------
;                    -------  POWER ON   -------
;                  -------------------------------
;
;  B7:   RBPU   - ENABLE PORT B PULL-UP RES,       1=OFF
;  B6:   INTEDG - RB0 INT EDGE SEL                 0=-VE
;  B5:   T0CS   - TMR0 SOURCE,       0=FOSC/4, 1=RA4 PIN
;  B4:   T0SE   - RA4CLK PIN EDGE SELECT,          0=+VE
;  B3:   PSA    - PRESCALE ASSIGN         0=TIMER, 1=WDG
;  B2-0: PS2-0  - PRESCALE RATE 111=256 FOR TIMER (=128 FOR WDT)
;
;
INIZIO
        bsf     status,rp0      ; OPTION & TRIS ARE HI REGS
        movlw   10000000b       ;vedi sotto
        movwf   option_reg
;
; Pullup disabilitato
; Source TMR0 assegnato a fosc/4
; Rb0 interrupt su fronte di discesa
; Prescaler assegnato a TMR0    TMR0 conta ad 500KHz
; Divisore prescaler = 2
;
        movlw   00000011b       ; 0=OUTPUT   1=INPUT
        movwf   trisA
        movlw   00000011b       ; 0=OUTPUT   1=INPUT
        movwf   trisB
        bcf     status,rp0      ; BACK TO LO REGS
;
; -- enable bit
;     B7: GIE  - GLOBAL INT enable,                   0=OFF
;     B6: EEIE - EEPROM WRITE DONE INT enable,        0=OFF
;     B5: T0IE - TMR0 O/FLOW INT enable,              0=OFF
;     B4: INTE - RB0 INT enable,                      0=OFF
;     B3: RBIE - PORTB CHANGE-OF-STATE INT enable,    0=OFF
; -- flag bit
;     B2: T0IF - TMR0 O'FLOW flag,   1=O/FLOW, S/WARE MUST RESET
;     B1: INTF - RB0 INT flag,                      ACTIVE HIGH
;     B0: RBIF - PORTB CHANGE-OF-STATE flag,        ACTIVE HIGH
;
        clrf    intcon          ;nessun INT usato per ora
        bsf     PortA,auto_m    ;attiva automantenimento power
;
        call    lcd_init        ;inizializza display
        call    load_dati       ;ricarica valori salvati
;
        clrf    tmr0
        movlw   10110000b       ;GIE + T0IE + INTE
        movwf   intcon          ;abilita int.
Show_me
     send  banner               ;display  messaggio iniziale
;
        movlw   10              ;10 secondi per visualizzare
        movwf   r2
ri100
        movlw   100
        call    rwms            ;rit. W*1msec
        decfsz  r2,f            ;questo fa 100ms x W
        goto    ri100
;
        movlw   disp_on         ;disab. cursore
        call    WR_cmd
        call    tastof          ;i tasti devono essere rilasciati
        bsf     PortA,led       ;spegne led
        clrf    V_picco
        clrf    funct           ;visualizza velocita'
;
Main_l
        bsf     PortA,auto_m    ;rinfresca power ON
        call    tasti           ;controlla se richiesta qualche funzione
        movfw   button          ;riprende il valore
        skpz
        goto    user            ;va alla gestione funzioni
;
;controlla vbatt  ed errori
;
        clrf    V_att           ;presuppone che sia fermo
        btfsc   Tim_Hi,6        ;se = 1 significa che sono passati > 4sec
        goto    visual          ;quindi aggiorna il display di conseguenza
;
        btfss   flag1,new       ;disponibile nuovo valore
        goto    main_l          ;no aspetta
;
;calcola nuovi valori di velocita'
;
        call    speed           ;calcola velocita'
        call    peak            ;rileva velocita' di picco
        call    barra           ;calcola lung. barra analogica
visual
        bcf     Tim_hi,7
        bcf     Tim_hi,6        ;impedisce l'overflow
        call    show_bar        ;visualizza la barra velocita'
        movlw   10              ;cursor Home lower
        call    printW
;
;determina quale funzione deve visualizzare
;
        movlw   HIGH botab
        movwf   pclath
        movfw   funct           ;contatore circolare di funzione
        andlw   00000011b       ;per sicurezza limita a 0-3
botab
        addwf   pcl,f           ;simula  ON (X)  GOTO0,GOTO1,GOTO2,ecc.
;funz. 0
        goto    v_info          ;velocita' attuale  + vel. picco
;funz. 1
        goto    totale_km       ;contaKm totale
;funz. 2
        goto    parziale_km     ;contaKm parziale
;funz. 3
        goto    main_l          ;non usato  non dovrebbe mai venire qui
;
totab
;
   if ( ( HIGH botab ) < ( HIGH totab ) )
        MESSG   "ATTENZIONE --- : Tabella attraversa pagina"
   endif
;
;
;          visualizza velocita'
V_info
        movfw   V_att           ;velocita' attuale
        call    L_bcd           ;display in bcd
      send      Kmh             ;aggiunge unita' di misura
        call    spazio
        call    spazio          ;cancella sbordamenti
        movlw   192+9
        call    Wr_cmd          ;posiziona cursore
      send      Pik             ;display MAX
        movfw   V_picco         ;velocita' Max
        call    L_bcd           ;display in bcd
        call    spazio          ;puo' sbordare oltre ma non si vede
        goto    have_rest
;
;*******************************
;visualizza in BCD il parziale dei Km percorsi
Parziale_km
        call    azz_acc
      copyf     Par_lo,ACCaLo   ;parziale impulsi contati
      copyf     Par_mi,ACCaMid
      copyf     Par_hi,ACCaHi
        call    conta_km        ;display risultato
      send      Par
        goto    have_rest
;
;*******************************
;visualizza in BCD il totale dei Km percorsi
Totale_km
        call    azz_acc
      copyf     Tot_lo,ACCaLo   ;totale impulsi contati
      copyf     Tot_mi,ACCaMid
      copyf     Tot_hi,ACCaHi
        call    conta_km
      send      Tot             ;aggiunge il tipo di visualzz.
;
have_rest
        bsf     PortA,led       ;spegne  led
        bcf     flag1,new       ;evita rientro  al prossimo giro
        call    r100ms          ;riposa un po'  dopo tutti sti conti
        goto    Main_l
;
;
;....................
User
        movfw   button          ;riprende il valore
      cjnug     Pu1,button,che_vo       ;tasto di scambio funz
;
;ogni volta che si preme Pu1 cambia i dati visualizzati
;e riazzera la V_picco
;
        call    tastof
        incf    funct,f         ;passa alla funzione segg.
      cjmin     3,funct,fu_val  ;controllo che ruoti tra 0 e 2
        clrf    funct           ;altrimenti la riporta a 0
fu_val
        clrf    V_picco         ;riazzera Vel. picco
        movlw   12              ;cancella tutto display
        call    printW
        goto    main_l          ;si usa come debounce
che_vo
        movlw   disp_on_bc      ;abilita cursore lampeggiante
        call    WR_cmd
Set_up
      send      Finito          ;messaggio EXIT setup
        call    flip            ;rilascio/pressione tasto
      cjug      Pu2,button,show_me      ;uscita setup
;
      send      Spegni          ;messaggio Power off
        call    flip
      cjug      Pu2,button,quit         ;conferma  Power off
;
      send      Killtot         ;messaggio cancella totalizzatore
        call    flip
      cjug      Pu2,button,er_to        ;conferma cancellazione
;
      send      Killpar         ;messaggio cancella parziale
        call    flip
      cjug      Pu2,button,er_pa        ;conferma cancellazione
;
      send      Set_bar         ;messaggio setup barra analogica
        call    flip
      cjug      Pu2,button,top_barra    ;conferma cancellazione
;
        goto    set_up          ;roll continuo  fino alla selezione di exit
;
Quit
      send      Okk
        call    flip
      cjug      Pu1,button,set_up       ;non conferma power off
        call    save_dati               ;salva in eeprom
        bcf     INTCON,gie              ;stop interrupt
      send      Ciao					;saluta 
dead
        call    tastof      		    ;rilascio tasto
        bcf     PortA,auto_m            ;toglie automantenimento
        goto    dead                    ;attende caduta alimentazione
;
Er_to
      send      Okk
        call    flip
      cjug      Pu1,button,set_up       ;non conferma power off
        clrf    Tot_lo          ;riazzera per la prossima misura
        clrf    Tot_mi
        clrf    Tot_hi
        goto    show_me
;
Er_pa
      send      Okk
        call    flip
      cjug      Pu1,button,set_up       ;non conferma power off
        clrf    Par_lo          ;riazzera per la prossima misura
        clrf    Par_mi
        clrf    Par_hi
        goto    show_me
;
Top_barra
        movlw   10
        call    printW          ;cursor Home lower
        movfw   Bar_max
        call    L_bcd
        call    spazio
      send      Pik             ;aggiunge MAx.
        call    spazio
        call    spazio
        call    flip
      cjug      Pu1,button,show_me      ;conferma il valore off
        incf    Bar_max,f               ;aggiorna valore
        goto   top_barra
;
;*******************************
;calcola la velocita' ( circonf. ruota * 1800 ) / tempo per
;una rivoluzione il risultato e' un numero intero tra 0 e  255
;che indica direttamente la velocita' in Km/h
;N.B. il numero e' in binario occorre convertire in BCD
Speed
        call    azz_acc         ;predispone per le operazioni
        movlw   (dividendo >> 16 & 255)           ;msb a 24 bit
        movwf   ACCcHi
        movlw   (dividendo >> 8 & 255)            ;mid
        movwf   ACCcMid
        movlw   (dividendo & 255)                 ;low
        movwf   ACCcLo
;
      copyf     Mir_hi,ACCaHi   ;copia tempo rivoluzione nel divisore
      copyf     Mir_mi,ACCaMid
      copyf     Mir_lo,ACCaLo
        call    div24
; controlla che non superi 255 altrimenti si visualizzano valori errati
        movfw   ACCcHi          ;valuta la parte MSD del risultato
        iorwf   ACCcMid,w
        skpz                    ;se 0 valore valido
        goto    fix             ;altrimenti la fissa al max
        movfw   ACCcLo          ;considera valori tra 0 e 255
        movwf   V_att           ;la conserva per gli altri usi
        return
fix
        movlw   255
        movwf   V_att           ;al max.
        return
;
;       movfw   mir_hi          ; X debug
;       call    hexout
;       movfw   mir_mi
;       call    hexout
;       movfw   mir_lo
;       call    hexout
;
;       movfw   ACCcHi
;       call    hexout
;       movfw   ACCcMid
;       call    hexout
;       movfw   ACCcLo
;       call    hexout
;
;verifica se la vel. attuale e' > di quella di picco precedente
;***********************
Peak
        movfw   V_att           ;ricava vel. max
        subwf   V_picco,w
        skpnc
        return
     copyf      V_att,v_picco   ;aggiorna il valore
        return
;
;*--------------------------------------------------
;       movfw   ACCcHi          ;display Km  con risoluzione
;       call    hexout          ;di 100m
;       movfw   ACCcMid
;       call    hexout
;       movfw   ACCcLo
;       goto    hexout
;
;*******************************
;calcola lo spazio percorso  (circ. ruota * impulsi)/100.000
;si ottiene risultato con risoluzione di 100m
Conta_km
        movlw   (ruota & 255)
        movwf   ACCbLo
        movlw   (ruota >> 8 & 255)
        movwf   ACCbMid         ; impulsi x circonf. della ruota
;   ACCb * ACCa       24 bit * 24 bit
        call    mpy24           ;risultato = spazio percorso in mm.
;risultato in ACCb e ACCc  56 bit
        movlw   (centomila & 255)
        movwf   ACCaLo
        movlw   (centomila >> 8 & 255)
        movwf   ACCaMid
        movlw   (centomila >> 16 & 255)
        movwf   ACCaHi          ;ora lo divide x 100000
;  ACCb,ACCc / ACCa      56 bit / 24 bit
        call    div24
; risultato in ACCc
      copyf     ACCcLo,reg0     ;trasferisce per la conversione long BCD
      copyf     ACCcMid,reg1
      copyf     ACCcHi,reg2
;
        call    Bin2bcd         ;il risultato in dig0,dig1,dig2,dig3 = Msd
;
;visualizza il risultato della conversione inserendo
;il punto e la virgola decimale per le centinaia di metri
;
        movlw   dig3            ;nn nn nn nn
        movwf   fsr             ;inizia da Msd

        movfw   indf            ;tralascia i milioni di Km
        call    Hexasc          ;visualizza in ASCII  solo Lo nibble
        decf    fsr,f           ;passa al segg
        movfw   indf
        call    Hexout          ;visualizza hi e lo nibble
        movlw   "."             ;punto migliaia
        call    printW
        decf    fsr,f           ;passa alle centinaia
        movfw   indf
        call    Hexout          ;visualizza hi e lo nibble
        decf    fsr,f           ;passa alle centinaia
        swapf   indf,w          ;preleva la parte hi
        andlw   15
        call    Hexasc          ;visualizza in ASCII  solo Hi nibble
        movlw   ","             ;virgola decimali
        call    printW
        movfw   indf
        call    Hexasc          ;visualizza in ASCII  solo Lo nibble
;
      send      Km              ;aggiunge unita' di misura
        return
;
;
;*******************************
;calcola quanti dot sono necessari per visualizzare la velocita'
;in formato analogico  , il fondo scala della barra e programmabile
;parameti  Bar_max = fondo scala della barra
;          V_att   = velocita' attuale
; calcolo
;       V_att * 128     per non perdere i decimali
;    percento = (V_att * 128) / Bar_max
;  ritorna un numero tra 0 e 128  proporzionale alla V_att
;  barra = percento * N_eleme  ( da quanti dot e' formata la bara )
;  ritorna un numero tra 0 e 2048
;  dot_bar = barra / 128   recupera la moltipl. in testa
;  ritorna un numero tra 0 e 16
Barra
        call    azz_acc
; controllo limiti V. attuale se > della max. visualizzabile la
; fissa al max
      copyf     V_att,ACCaLo    ;presume sia in range
        movfw   bar_max
        subwf   V_att,w         ;se Max f.s. >= V_att lo accetta valido
        bnc     acc_t
      copyf     bar_max,ACCaLo  ;lo fissa al f.s. della barra
acc_t
        movlw   128             ;moltiplica * 128 per non perdere i decim.
        movwf   ACCbLo
        call    mpy24           ;risultato = V_att * 128 in ACCcMid,Lo
      copyf     bar_max,ACCaLo  ;riprende V.max per  100% di barra
        clrf    ACCaMid         ;puo' essere variato risiede in eeprom
        clrf    ACCaHi
        call    div24           ;calcola percentuale di barra accesa
      copyf     ACCcLO,temp     ;salva percent
        call    azz_acc
      copyf     temp,ACCaLo
        movlw   N_eleme         ;di quanti elementi e' composta la barra
        movwf   ACCbLo          ;fisso a 16 per questo display
        call    mpy24           ;percent * elementi
        movlw   128             ;ridivide * 128 per avere il numero in %
        movwf   ACCaLo          ;nel divisore
        clrf    ACCaMid
        clrf    ACCaHi
;                       0/n  ???      controllare  se funziona
        call    div24
      copyf     ACCcLo,dot_bar
        return
;
;*******************************
;visualizza su I riga del display una barra analogica il carattere
; con cui forma la barra cambia a seconda del valore di dot_bar
Show_bar
; controlla i limiti per evitare sbordamenti
        movlw   shape                   ;presuppone che sia in range
        movwf   r2                      ;conserva simbolo
      cjnug     0,dot_bar,sh_ok         ;contollo se 0
        incf    dot_bar,f               ;ne fissa almeno 1
        movlw   sh_lo                   ;e cambia simbolo
        movwf   r2
;
;visualizza la barra su I riga display
;
sh_ok
        movlw   11              ;cursor Home upper
        call    printW
        movlw   N_eleme         ;lungh max della barra
        movwf   r1              ;nel contatore di riempimento
bar_s
        movfw   r2              ;recupera il simbolo da usare
        call    printW          ;almeno uno lo stampa sempre
        decf    r1,f            ;tiene in passo il contatore
        decfsz  dot_bar,f       ;conta quanti simboli visualizzare
        goto    bar_s
blank
      csnug     0,r1            ;se ha riempito la barra termina
        return
        movlw   ' '             ;cancella da dove e' arrivato alla fine
        call    printW
        decfsz  r1,f
        goto    blank
        return
;
; -------------------- zona EEPROM ----------
;
        org     2100h
;
        de      00,00,00        ;deposito totalizzatore pulse sensore
        de      00,00,00        ;deposito parziali pulse sensore
        de      V_M_barra       ;deposito vel. fondo scala barra analog.
        de      00,00,00        ;
        de      00,00,00        ;
;
;
        END

